﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	
	Private Const APP_TITLE As String = "DMX Client"
	Private Const APP_VERSION As String = "200240605"
	Private Const APP_INFO As String = "Example controlling an LED PAR in DMX512 Mode using the DMX Controller Arduino MEGA with B4R."
	
	Private Root As B4XView
	Private xui As XUI
	Private btnConnect As B4XView
	Private lblConnectStatus As B4XView
	Private btnSetChannelValue As B4XView
	Private spAddress As Spinner
	Private slDimmer As Slider
	Private slRed As Slider
	Private slGreen As Slider
	Private slBlue As Slider
	Private spChannel As Spinner
	Private tfHostIP As B4XView
	Private tfValue As B4XView
	Private lvLog As ListView
	Private blnClearLog As B4XView
	Private lblInfo As B4XView
	
	'Communication
	Private sock As Socket
	Private isConnected As Boolean
	Private astream As AsyncStreams
   
	Private Const HOST_IP As String = "<YOUR_IP>"
	Private Const HOST_PORT As Int = 80

	'LED
	Private Const CHANNEL_MIN As Int = 1
	Private Const CHANNEL_MAX As Int = 512
	Private Const VALUE_MIN As Int = 0
	Private Const VALUE_MAX As Int = 255
	Private LED_Address As Int = 1
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	'Set mainpage properties
	B4XPages.SetTitle(Me, $"${APP_TITLE} - ${APP_VERSION}"$)
	B4XPages.GetNativeParent(Me).Resizable = False    
	
	'Set defaults
	tfHostIP.Text = HOST_IP
	lblConnectStatus.Text = "Disconnected"
	lblInfo.Text = APP_INFO
	
	spAddress.Value = LED_Address
	slDimmer.Value = VALUE_MIN
	slRed.Value = VALUE_MIN
	slGreen.Value = VALUE_MIN
	slBlue.Value = VALUE_MIN

	'Connect the socket 
	'sock_Connect
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub btnConnect_Click
	sock_Connect
End Sub

Private Sub spAddress_ValueChanged (Value As Object)
	LED_Address = Value
End Sub

Private Sub slDimmer_ValueChange (Value As Double)
	Set_Channel_Value(LED_Address, Value)
End Sub

Private Sub slRed_ValueChange (Value As Double)
	Set_Channel_Value(LED_Address + 1, Value)
End Sub

Private Sub slGreen_ValueChange (Value As Double)
	Set_Channel_Value(LED_Address + 2, Value)
End Sub

Private Sub slBlue_ValueChange (Value As Double)
	Set_Channel_Value(LED_Address + 3, Value)
End Sub

Private Sub spChannel_ValueChanged (Value As Object)
	Log($"spChannel_value_Changed: ${Value}"$)
End Sub

Private Sub tfValue_Action
	btnSetChannelValue_Click
End Sub

Private Sub btnSetChannelValue_Click
	Set_Channel_Value(spChannel.Value, tfValue.Text.As(Int))
End Sub

Private Sub blnClearLog_Click
	lvLog.Items.Clear	
End Sub

#Region Communication
Sub sock_Connect
	sock.Initialize("sock")
	sock.Connect(tfHostIP.Text, HOST_PORT, 10000)
End Sub

'Handle socket connection
Sub sock_Connected (Successful As Boolean)
	ToLog("sock_Connected:" & Successful)
	isConnected = Successful
	If Successful Then
		astream.Initialize(sock.InputStream, sock.OutputStream, "astream")
		lblConnectStatus.Text = "Connected"
	Else
		ToLog("[ERROR]Can not connect to the DMX Controller.")
		lblConnectStatus.Text = "Disconnected"
	End If
End Sub

'Log data received from the Arduino DMX RESTFul server.
'The data comes in as chunks.
'Logging is NOT used.
Sub astream_NewData (Buffer() As Byte)
	'Dim bc As ByteConverter	'Lib ByteConverter
	'Log($"[astream_NewData]${bc.StringFromBytes(Buffer,"UTF-8")}"$)
End Sub

'Set DMX channel and value
Sub Set_Channel_Value(channel As Int, value As Int)
	If Not(isConnected) Then Return

	If (channel >= CHANNEL_MIN And channel <= CHANNEL_MAX) And (value >= VALUE_MIN And value <= VALUE_MAX) Then
		astream.Write($"/channel=${channel}&value=${value}&disconnect=0"$.GetBytes("UTF8"))
		ToLog($"[Set_Channel_Value]channel=${channel},value=${value}"$)
	Else
		ToLog($"[ERROR]Can not set channel ${channel} or value ${value} for the DMX Controller. Check if in range."$)
	End If
End Sub
#End Region

#Region Helpers

Private Sub ToLog(msg As String)
	lvLog.Items.InsertAt(0, msg)
	Log(msg)
End Sub
#End Region
