# B4R Library rConceptinetics - README Example DMXRESTServer

## Purpose
To control DMX lights from a desktop application sending commands to an Arduino DMX Controller via HTTP.

## Concept
An Arduino MEGA with an Arduino Ethernet shield and an Arduino DMX shield runs an B4R program acting as a HTTP RESTful server.
The RESTful server listens for commands send via HTTP GET requests from clients like B4J-App, Browser, Node-RED, Python.
The HTTP GET request arguments (must be lowercase!):
* channel=1-512 (mandatory)
* value=0-255 (mandatory)
* disconnect=0 or 1 (optional, default 1 = disconnect after executing command)
The disconnect argument can be used to keep a connection until closed by the client,
else socket connection made, channel and value set and socket connection is closed.
```
http://NNN.NNN.NNN.NNN/channel=1-512&value=0-255&disconnect=0|1
```

**Example Browser HTTP GET Request**
Control an LED with address 1 and the 4 channels Dimmer-RED-GREEN-BLUE.
The address applies to the first channel as set on the LED:
The LED has on the back a digital display with 4 setting button which is set to DMX Mode d0001.

* Set channel 1 (Total Dimming) to full: http://NNN.NNN.NNN.NNN/channel=1&value=255
* Set channel 4 (Blue) to low: http://NNN.NNN.NNN.NNN/channel=4&value=10

Note: The connection is disconnected (argument disconnect=1) after every command.

## Hardware
* 1x Arduino MEGA
* 1x Arduino Ethernet Shield with W5100 chip
* 1x CQRobot DMX Shield MAX485 for MCU
* 1x LED Mini Flat Par Light LSPA36RC (DMX512 with 3-7 channels)
* 1x Adam Hall Cables 3 STAR DMF 0600 DMX Cable 3-Pol XLR Female auf 3-Pol XLR male 6 m 
* 1x Adam Hall Connectors 3 STAR DMX T 3 XLR Cable 3-Pol woth 120OHM resistor

## Software
* B4R 4.0 - DMXController
* B4R Additional Library rConceptinetics 0.5
* B4J 10.0 - DMXClient Non-UI, UI

## Notes
* For more information, see README.md of the rConceptinetics library.
* This RESTful server concept could also be used for other applications.
